﻿//EX1002_ADC_FEZ_Panda_II
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;
using GHIElectronics.NETMF.Hardware;


namespace EX1002_ADC_FEZ_Panda_II
{
    public class Program
    {
        public static void Main()
        {
            AnalogIn ADC0 = new AnalogIn((AnalogIn.Pin)FEZ_Pin.AnalogIn.An0);
            AnalogIn ADC1 = new AnalogIn((AnalogIn.Pin)FEZ_Pin.AnalogIn.An1);
            //AnalogIn ADC2 = new AnalogIn((AnalogIn.Pin)FEZ_Pin.AnalogIn.An2);
            //AnalogIn ADC3 = new AnalogIn((AnalogIn.Pin)FEZ_Pin.AnalogIn.An3);
            //AnalogIn ADC4 = new AnalogIn((AnalogIn.Pin)FEZ_Pin.AnalogIn.An4);
            //AnalogIn ADC5 = new AnalogIn((AnalogIn.Pin)FEZ_Pin.AnalogIn.An5);
            
            bool ledState = false;
            OutputPort led = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, ledState);

            while (true)
            {
                Debug.Print("ADC0 = " + ADC0.Read().ToString());
                Debug.Print("ADC1 = " + ADC1.Read().ToString());              

                Thread.Sleep(500);
                // toggle LED state
                ledState = !ledState;
                led.Write(ledState);

                Thread.Sleep(1000);
                ADC1.SetLinearScale(-3300, 3300);
                Debug.Print("ADC1 with new Range = " + ADC1.Read().ToString());
                Thread.Sleep(1000);
                ADC1.SetLinearScale(0, 3300);                

            }
        }

    }
}
