﻿//EX1101_LAN_Netduino
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Microsoft.SPOT.Net;
using Microsoft.SPOT.Net.NetworkInformation;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;

namespace EX1101_LAN_Netduino
{
    public class Program
    {
        public static void Main()
        {
            NetworkInterface[] mynetwork = NetworkInterface.GetAllNetworkInterfaces();

            foreach (NetworkInterface mynetworkInterface in mynetwork)
            {

                Debug.Print("My TCP/IP address is " + mynetworkInterface.IPAddress);
            }


            OutputPort BLUE_LED = new OutputPort(Pins.ONBOARD_LED, false);

            const Int32 network_port = 12000;

            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPEndPoint localEndPoint = new IPEndPoint(IPAddress.Any, network_port);
            server.Bind(localEndPoint);
            server.Listen(Int32.MaxValue);

            while (true)
            {

                Socket clientSocket = server.Accept();
                const Int32 c_microsecondsPerSecond = 1000000;

                using (clientSocket)
                {

                    Byte[] buffer = new Byte[1024];
                    if (!clientSocket.Poll(5 * c_microsecondsPerSecond, SelectMode.SelectRead))
                    {
                        // We waited 5 seconds and no bytes are ready to read,
                        return;
                    }
                    Int32 bytesRead = clientSocket.Receive(buffer);

                    Char[] charBuff = System.Text.UTF8Encoding.UTF8.GetChars(buffer);
                    string sResult = "";
                    sResult = new string(charBuff);
                    if (sResult == "LED ON")
                    {
                        BLUE_LED.Write(true);
                    }
                    if (sResult == "LED OFF")
                    {
                        BLUE_LED.Write(false);
                    }

                    Debug.Print(sResult);

                }               

            }
        }
    }
}
