﻿//EX1303_Canvas
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;

using Microsoft.SPOT;
using Microsoft.SPOT.Input;
using Microsoft.SPOT.Presentation;
using Microsoft.SPOT.Presentation.Controls;
using Microsoft.SPOT.Presentation.Media;
using Microsoft.SPOT.Presentation.Shapes;

namespace EX1303_Canvas
{
    public class Program : Microsoft.SPOT.Application
    {
        public static void Main()
        {
            Program myApplication = new Program();

            Window mainWindow = myApplication.CreateWindow();

            // Create the object that configures the GPIO pins to buttons.
            //GPIOButtonInputProvider inputProvider = new GPIOButtonInputProvider(null);

            // Start the application
            myApplication.Run(mainWindow);
        }

        private Window mainWindow;

        public Window CreateWindow()
        {
            // Create a window object and set its size to the
            // size of the display.
            mainWindow = new Window();
            mainWindow.Height = SystemMetrics.ScreenHeight;
            mainWindow.Width = SystemMetrics.ScreenWidth;

            Canvas myCanvas = new Canvas();
            mainWindow.Child = myCanvas;

            //Add Picture to the panel
            Bitmap CarAtBeach = Resources.GetBitmap(Resources.BitmapResources.CarAtBeach);
            Image myImage = new Image(CarAtBeach);
            Canvas.SetTop(myImage, 10);
            Canvas.SetLeft(myImage, 10);
            myCanvas.Children.Add(myImage);

            // Create a single text control.
            Text myText = new Text("Car at the Beach");
            myText.Font = Resources.GetFont(Resources.FontResources.small);
            myText.ForeColor = ColorUtility.ColorFromRGB(255, 200, 50);
            Canvas.SetRight(myText, 10);
            Canvas.SetTop(myText, 10);
            myCanvas.Children.Add(myText);

            //Add a shape
            Rectangle myRectangle = new Rectangle();
            myRectangle.Fill = new SolidColorBrush(Colors.Blue);
            myRectangle.Width = 300;
            myRectangle.Height = 40;
            Canvas.SetBottom(myRectangle, 50);
            Canvas.SetLeft(myRectangle, 10);
            myCanvas.Children.Add(myRectangle);

            
            // Add the text control to the window.
            //mainWindow.Child = text;

            // Connect the button handler to all of the buttons.
            //mainWindow.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(OnButtonUp), false);

            // Set the window visibility to visible.
            mainWindow.Visibility = Visibility.Visible;

            // Attach the button focus to the window.
            //Buttons.Focus(mainWindow);

            return mainWindow;
        }


    }
}
