﻿//EX1304_MultiWindow
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;

using Microsoft.SPOT;
using Microsoft.SPOT.Input;
using Microsoft.SPOT.Presentation;
using Microsoft.SPOT.Presentation.Controls;
using Microsoft.SPOT.Presentation.Media;
using Microsoft.SPOT.Presentation.Shapes;
using Microsoft.SPOT.Hardware;


namespace EX1304_MultiWindow
{
    public class Program : Microsoft.SPOT.Application
    {
        public static void Main()
        {
            Program myApplication = new Program();


            Window sub1 = myApplication.CreatesubWin1();
            Window sub2 = myApplication.CreatesubWin2();
            Window sub3 = myApplication.CreatesubWin3();
            Window sub4 = myApplication.CreatesubWin4();
            Window sub5 = myApplication.CreatesubWin5();
            Window mainWin = myApplication.CreateWindow();

            // Create the object that configures the GPIO pins to buttons.
            GPIOButtonInputProvider inputProvider = new GPIOButtonInputProvider(null);

            // Start the application
            myApplication.Run(mainWin);
        }

        private Window mainWindow;
        public ListBox mylistBox = new ListBox();

        public Window CreateWindow()
        {
            // Create a window object and set its size to the
            // size of the display.
            mainWindow = new Window();
            mainWindow.Height = SystemMetrics.ScreenHeight;
            mainWindow.Width = SystemMetrics.ScreenWidth;

            //StackPanel
            StackPanel mainPanel = new StackPanel();
            mainWindow.Child = mainPanel;

            Font largeFont = Resources.GetFont(Resources.FontResources.linds);

            // Create a single text control.
            Text text = new Text(Resources.GetFont(Resources.FontResources.small), "Please Select a Window");
            text.HorizontalAlignment = Microsoft.SPOT.Presentation.HorizontalAlignment.Center;
            mainPanel.Children.Add(text);

            Text blankLine = new Text(largeFont, "");
            mainPanel.Children.Add(blankLine);

            Text PictureText = new Text(largeFont, "View some Text");
            PictureText.TextAlignment = TextAlignment.Center;
            PictureText.ForeColor = Colors.Gray;
            PictureText.Width = mainWindow.Width;
            ListBoxItem PictureTextItem = new ListBoxItem();
            PictureTextItem.Child = PictureText;
            mylistBox.Items.Add(PictureTextItem);

            Text myText = new Text(largeFont, "View Canvas");
            myText.TextAlignment = TextAlignment.Center;
            myText.ForeColor = Colors.Gray;
            myText.Width = mainWindow.Width;
            ListBoxItem myTextItem = new ListBoxItem();
            myTextItem.Child = myText;
            mylistBox.Items.Add(myTextItem);

            Text CanvasText = new Text(largeFont, "View Stack Panel");
            CanvasText.TextAlignment = TextAlignment.Center;
            CanvasText.ForeColor = Colors.Gray;
            CanvasText.Width = mainWindow.Width;
            ListBoxItem CanvasTextItem = new ListBoxItem();
            CanvasTextItem.Child = CanvasText;
            mylistBox.Items.Add(CanvasTextItem);

            Text SystemText = new Text(largeFont, "Current Time");
            SystemText.TextAlignment = TextAlignment.Center;
            SystemText.ForeColor = Colors.Gray;
            SystemText.Width = mainWindow.Width;
            ListBoxItem SystemTextItem = new ListBoxItem();
            SystemTextItem.Child = SystemText;
            mylistBox.Items.Add(SystemTextItem);            
                       
            Text mySystemInfo = new Text(largeFont, "View System Info");
            mySystemInfo.TextAlignment = TextAlignment.Center;
            mySystemInfo.ForeColor = Colors.Gray;
            mySystemInfo.Width = mainWindow.Width;
            ListBoxItem mySystemInfoItem = new ListBoxItem();
            mySystemInfoItem.Child = mySystemInfo;
            mylistBox.Items.Add(mySystemInfoItem);
                     

            //Dedect when a selection change has been made in the listbox
            mylistBox.SelectionChanged += new SelectionChangedEventHandler(mylistBox_SelectionChanged);

            mylistBox.SelectedIndex = 0;    // select the first item

            mainPanel.Children.Add(mylistBox);  // add to the display

             // Connect the button handler to all of the buttons.
            mainWindow.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(OnButtonUp), false);

            // Set the window visibility to visible.
            mainWindow.Visibility = Visibility.Visible;

            // Attach the button focus to the listbox.
            Buttons.Focus(mylistBox);

            return mainWindow;
        }

        void mylistBox_SelectionChanged(object sender, SelectionChangedEventArgs args)
        {
            int prevIndex = args.PreviousSelectedIndex;
            if (prevIndex != -1)
            {
                ((Text)mylistBox.Items[prevIndex].Child).ForeColor = Colors.Gray;

            }
            ((Text)mylistBox.Items[args.SelectedIndex].Child).ForeColor = Colors.Red;
        }

        private void OnButtonUp(object sender, RoutedEventArgs evt)
        {
            ButtonEventArgs e = (ButtonEventArgs)evt;

            // Print the button code to the Visual Studio output window.
            Debug.Print(e.Button.ToString());

            if (e.Button == Button.VK_SELECT)
            {
                switch (mylistBox.SelectedIndex)
                {
                    case 0:
                        Debug.Print("Text");
                        mainWindow.Visibility = Visibility.Collapsed;
                        subWin1.Visibility = Visibility.Visible;
                        Buttons.Focus(subWin1);
                        break;

                    case 1:
                        Debug.Print("Canvas");
                        mainWindow.Visibility = Visibility.Collapsed;
                        subWin2.Visibility = Visibility.Visible;
                        Buttons.Focus(subWin2);

                        break;

                    case 2:
                        Debug.Print("StackPanel");
                        mainWindow.Visibility = Visibility.Collapsed;
                        subWin3.Visibility = Visibility.Visible;
                        Buttons.Focus(subWin3);
                        break;
                    case 3:
                        Debug.Print("System Time");
                        mainWindow.Visibility = Visibility.Collapsed;
                        subWin4.Visibility = Visibility.Visible;
                        Buttons.Focus(subWin4);
                        break;

                    case 4:
                        Debug.Print("System Information");
                        mainWindow.Visibility = Visibility.Collapsed;
                        subWin5.Visibility = Visibility.Visible;
                        Buttons.Focus(subWin5);
                        break;
                 }
            }

        }

        public Window subWin1 = new Window();

        public Window CreatesubWin1()
        {
            // set its size to the
            // size of the display.

            subWin1.Height = SystemMetrics.ScreenHeight;
            subWin1.Width = SystemMetrics.ScreenWidth;

            // Create a single text control.
            Text text = new Text();

            text.Font = Resources.GetFont(Resources.FontResources.linds);
            text.TextWrap = true;
            text.TextContent = "This is an example of some text places in a sub window. The text can be set to wrap and not go off the screen.";

            // Add the text control to the window.
            subWin1.Child = text;

            // Connect the button handler to all of the buttons.
            subWin1.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(SubWin1_OnUp), false);


            // Set the window visibility to visible.
            subWin1.Visibility = Visibility.Hidden;

            // Attach the button focus to the window.
            Buttons.Focus(subWin1);

            return subWin1;

        }

        private void SubWin1_OnUp(object sender, RoutedEventArgs evt)
        {

            ButtonEventArgs e = (ButtonEventArgs)evt;

            // Print the button code to the Visual Studio output window.
            Debug.Print(e.Button.ToString());

            if (e.Button == Button.VK_SELECT)
            {
                subWin1.Visibility = Visibility.Collapsed;
                mainWindow.Visibility = Visibility.Visible;
                Buttons.Focus(mylistBox);
            }

        }

        public Window subWin2 = new Window();

        public Window CreatesubWin2()
        {

            subWin2.Height = SystemMetrics.ScreenHeight;
            subWin2.Width = SystemMetrics.ScreenWidth;

            Canvas myCanvas = new Canvas();
            subWin2.Child = myCanvas;

            //Add Picture to the panel
            Bitmap CarAtBeach = Resources.GetBitmap(Resources.BitmapResources.CarAtBeach);
            Image myImage = new Image(CarAtBeach);
            Canvas.SetTop(myImage, 10);
            Canvas.SetLeft(myImage, 10);
            myCanvas.Children.Add(myImage);

            // Create a single text control.
            Text myText = new Text("Car at the Beach");
            myText.Font = Resources.GetFont(Resources.FontResources.small);
            myText.ForeColor = ColorUtility.ColorFromRGB(255, 200, 50);
            Canvas.SetRight(myText, 10);
            Canvas.SetTop(myText, 50);
            myCanvas.Children.Add(myText);


            //Add a shape
            Rectangle myRectangle = new Rectangle();
            myRectangle.Fill = new SolidColorBrush(Colors.Green);
            myRectangle.Width = 300;
            myRectangle.Height = 40;
            Canvas.SetBottom(myRectangle, 50);
            Canvas.SetLeft(myRectangle, 10);
            myCanvas.Children.Add(myRectangle);

            // Connect the button handler to all of the buttons.
            subWin2.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(SubWin2_OnUp), false);

            // Set the window visibility to visible.
            subWin2.Visibility = Visibility.Hidden;

            // Attach the button focus to the window.
            Buttons.Focus(subWin2);

            return subWin2;

        }

        private void SubWin2_OnUp(object sender, RoutedEventArgs evt)
        {

            ButtonEventArgs e = (ButtonEventArgs)evt;

            // Print the button code to the Visual Studio output window.
            Debug.Print(e.Button.ToString());

            if (e.Button == Button.VK_SELECT)
            {
                subWin2.Visibility = Visibility.Collapsed;
                mainWindow.Visibility = Visibility.Visible;
                Buttons.Focus(mylistBox);
            }

        }

        public Window subWin3 = new Window();

        public Window CreatesubWin3()
        {

            subWin3.Height = SystemMetrics.ScreenHeight;
            subWin3.Width = SystemMetrics.ScreenWidth;

            StackPanel myPanel = new StackPanel(Orientation.Vertical);
            subWin3.Child = myPanel;

            //Add Picture to the panel
            Bitmap CarAtBeach = Resources.GetBitmap(Resources.BitmapResources.CarAtBeach);
            Image myImage = new Image(CarAtBeach);
            myImage.HorizontalAlignment = HorizontalAlignment.Center;
            myPanel.Children.Add(myImage);

            // Create a single text control.
            Text myText = new Text("Car at the Beach");
            myText.Font = Resources.GetFont(Resources.FontResources.linds);
            myText.HorizontalAlignment = HorizontalAlignment.Center;
            myText.ForeColor = ColorUtility.ColorFromRGB(255, 200, 50);
            myPanel.Children.Add(myText);

            //Add Shape
            Ellipse myEllipse = new Ellipse(30,30);
            myEllipse.Fill = new SolidColorBrush(Colors.Cyan);
            myEllipse.HorizontalAlignment = HorizontalAlignment.Center;
            myPanel.Children.Add(myEllipse);

            // Connect the button handler to all of the buttons.
            subWin3.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(SubWin3_OnUp), false);

            // Set the window visibility to visible.
            subWin3.Visibility = Visibility.Hidden;

            // Attach the button focus to the window.
            Buttons.Focus(subWin3);

            return subWin3;

        }

        private void SubWin3_OnUp(object sender, RoutedEventArgs evt)
        {

            ButtonEventArgs e = (ButtonEventArgs)evt;

            // Print the button code to the Visual Studio output window.
            Debug.Print(e.Button.ToString());

            if (e.Button == Button.VK_SELECT)
            {
                subWin3.Visibility = Visibility.Collapsed;
                mainWindow.Visibility = Visibility.Visible;
                Buttons.Focus(mylistBox);
            }

        }


        public Window subWin4 = new Window();
        private DispatcherTimer clockTimer;
        public Text myTime = new Text();

        public Window CreatesubWin4()
        {

            subWin4.Height = SystemMetrics.ScreenHeight;
            subWin4.Width = SystemMetrics.ScreenWidth;

            StackPanel myTimePanel = new StackPanel(Orientation.Vertical);
            subWin4.Child = myTimePanel;


            // Create a single text control.
            Text myText = new Text("The Current Time is");
            myText.Font = Resources.GetFont(Resources.FontResources.linds);
            myText.HorizontalAlignment = HorizontalAlignment.Center;
            myText.ForeColor = ColorUtility.ColorFromRGB(255, 200, 50);
            myTimePanel.Children.Add(myText);

            Text blankLine = new Text(Resources.GetFont(Resources.FontResources.linds), "");
            myTimePanel.Children.Add(blankLine);

            myTime.TextContent = DateTime.Now.ToString("hh:mm:ss");
            myTime.Font = Resources.GetFont(Resources.FontResources.linds);
            myTime.ForeColor = ColorUtility.ColorFromRGB(0, 200, 255);
            myTime.HorizontalAlignment = HorizontalAlignment.Center;
            myTimePanel.Children.Add(myTime);

            clockTimer = new DispatcherTimer();
            clockTimer.Interval = new TimeSpan(0, 0, 0, 1, 0);
            clockTimer.Tick += new EventHandler(clockTimer_Tick);
            clockTimer.Start();

            // Connect the button handler to all of the buttons.
            subWin4.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(SubWin4_OnUp), false);

            // Set the window visibility to visible.
            subWin4.Visibility = Visibility.Hidden;

            // Attach the button focus to the window.
            Buttons.Focus(subWin4);

            return subWin4;
        }

        void clockTimer_Tick(object sender, EventArgs e)
        {
            myTime.TextContent = DateTime.Now.ToString("hh:mm:ss");
            myTime.Invalidate();
        }

        private void SubWin4_OnUp(object sender, RoutedEventArgs evt)
        {

            ButtonEventArgs e = (ButtonEventArgs)evt;

            // Print the button code to the Visual Studio output window.
            Debug.Print(e.Button.ToString());

            if (e.Button == Button.VK_SELECT)
            {
                subWin4.Visibility = Visibility.Collapsed;
                mainWindow.Visibility = Visibility.Visible;
                Buttons.Focus(mylistBox);
            }

        }

        public Window subWin5 = new Window();

        public Window CreatesubWin5()
        {

            subWin5.Height = SystemMetrics.ScreenHeight;
            subWin5.Width = SystemMetrics.ScreenWidth;

            StackPanel myCustomPanel = new StackPanel(Orientation.Vertical);
            subWin5.Child = myCustomPanel;


            // Create a single text control.
            Text myText = new Text("System Information");
            myText.Font = Resources.GetFont(Resources.FontResources.linds);
            myText.HorizontalAlignment = HorizontalAlignment.Center;
            myText.ForeColor = ColorUtility.ColorFromRGB(255, 50, 255);
            myCustomPanel.Children.Add(myText);

            Text blankLine = new Text(Resources.GetFont(Resources.FontResources.linds), "");
            myCustomPanel.Children.Add(blankLine);

            Text myModel = new Text("Model = " + Microsoft.SPOT.Hardware.SystemInfo.SystemID.Model.ToString());
            myModel.HorizontalAlignment = HorizontalAlignment.Left;
            myModel.Font = Resources.GetFont(Resources.FontResources.small);
            myModel.ForeColor = Colors.Black;
            myCustomPanel.Children.Add(myModel);

            Text myOEM = new Text("OEM = " + Microsoft.SPOT.Hardware.SystemInfo.SystemID.OEM.ToString());
            myOEM.HorizontalAlignment = HorizontalAlignment.Left;
            myOEM.Font = Resources.GetFont(Resources.FontResources.small);
            myOEM.ForeColor = Colors.Black;
            myCustomPanel.Children.Add(myOEM);

            Text mySKU = new Text("SKU = " + Microsoft.SPOT.Hardware.SystemInfo.SystemID.SKU.ToString());
            mySKU.HorizontalAlignment = HorizontalAlignment.Left;
            mySKU.Font = Resources.GetFont(Resources.FontResources.small);
            mySKU.ForeColor = Colors.Black;
            myCustomPanel.Children.Add(mySKU);

            Text myOEMString = new Text("OEMString = " + Microsoft.SPOT.Hardware.SystemInfo.SystemID.SKU.ToString());
            myOEMString.HorizontalAlignment = HorizontalAlignment.Left;
            myOEMString.Font = Resources.GetFont(Resources.FontResources.small);
            myOEMString.ForeColor = Colors.Black;
            myCustomPanel.Children.Add(myOEMString);

            Text myVer = new Text("Ver = " + Microsoft.SPOT.Hardware.SystemInfo.SystemID.SKU.ToString());
            myVer.HorizontalAlignment = HorizontalAlignment.Left;
            myVer.Font = Resources.GetFont(Resources.FontResources.small);
            myVer.ForeColor = Colors.Black;
            myCustomPanel.Children.Add(myVer);

            Text myDisplay = new Text("Display = " + SystemMetrics.ScreenWidth.ToString() + "x" + SystemMetrics.ScreenHeight.ToString() + " " + SystemMetrics.ScreenColorDepth.ToString() + "bpp");
            myDisplay.HorizontalAlignment = HorizontalAlignment.Left;
            myDisplay.Font = Resources.GetFont(Resources.FontResources.small);
            myDisplay.ForeColor = Colors.Black;
            myCustomPanel.Children.Add(myDisplay);

            // Connect the button handler to all of the buttons.
            subWin5.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(SubWin5_OnUp), false);

            // Set the window visibility to visible.
            subWin5.Visibility = Visibility.Hidden;

            // Attach the button focus to the window.
            Buttons.Focus(subWin5);

            return subWin5;

        }

        private void SubWin5_OnUp(object sender, RoutedEventArgs evt)
        {

            ButtonEventArgs e = (ButtonEventArgs)evt;

            // Print the button code to the Visual Studio output window.
            Debug.Print(e.Button.ToString());

            if (e.Button == Button.VK_SELECT)
            {
                subWin5.Visibility = Visibility.Collapsed;
                mainWindow.Visibility = Visibility.Visible;
                Buttons.Focus(mylistBox);
            }

        }





    }
}
