﻿//EX1402_GUI_HW_Cobra
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;

using Microsoft.SPOT;
using Microsoft.SPOT.Input;
using Microsoft.SPOT.Hardware;
using Microsoft.SPOT.Presentation;
using Microsoft.SPOT.Presentation.Controls;
using Microsoft.SPOT.Presentation.Media;
using Microsoft.SPOT.Presentation.Shapes;
using Microsoft.SPOT.Touch;
using GHIElectronics.NETMF.FEZ;
using GHIElectronics.NETMF.Hardware;
using Microsoft.SPOT.Presentation.Button;

namespace EX1402_GUI_HW_Cobra
{
    public class Program : Microsoft.SPOT.Application
    {
        public static void Main()
        {
            Program myApplication = new Program();

            Window mainWindow = myApplication.CreateWindow();

            // Create the object that configures the GPIO pins to buttons.
            GPIOButtonInputProvider inputProvider = new GPIOButtonInputProvider(null);

            Touch.Initialize(myApplication);

            // Start the application
            myApplication.Run(mainWindow);
        }

        private Window mainWindow;
        public OutputPort myLED = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, false);
        static Text myText;
        static Text ADC6Text;
        public Boolean mySW = false;
        public AnalogIn myADC;

        public Window CreateWindow()
        {
            // Create a window object and set its size to the
            // size of the display.
            mainWindow = new Window();
            mainWindow.Height = SystemMetrics.ScreenHeight;
            mainWindow.Width = SystemMetrics.ScreenWidth;

            Canvas myCanvas = new Canvas();

            // Add the text control to the window.
            mainWindow.Child = myCanvas;

            ButtonWPF myLEDButton = new ButtonWPF("LED", Resources.GetFont(Resources.FontResources.pesca));
            Canvas.SetTop(myLEDButton, 25);
            Canvas.SetLeft(myLEDButton, 25);
            myCanvas.Children.Add(myLEDButton);

            myLEDButton.Click += new EventHandler(myLED_Click);

            //demonstrate a single action to hardware by the Window
            myLED.Write(true);

            myText = new Text();
            myText.TextContent = "Waiting For Interrupt";
            myText.Font = Resources.GetFont(Resources.FontResources.kooten18);
            myText.ForeColor = Colors.Blue;
            Canvas.SetTop(myText, 100);
            Canvas.SetLeft(myText, 25);
            myCanvas.Children.Add(myText);

            ADC6Text = new Text();
            ADC6Text.Font = Resources.GetFont(Resources.FontResources.kooten18);
            ADC6Text.ForeColor = Colors.Blue;
            Canvas.SetTop(ADC6Text, 150);
            Canvas.SetLeft(ADC6Text, 25);
            myCanvas.Children.Add(ADC6Text);

            // Connect the button handler to all of the buttons.
            mainWindow.AddHandler(Buttons.ButtonUpEvent, new RoutedEventHandler(OnButtonUp), false);

            // Set the window visibility to visible.
            mainWindow.Visibility = Visibility.Visible;

            // Attach the button focus to the window.
            Buttons.Focus(mainWindow);

            myADC = new AnalogIn((AnalogIn.Pin)FEZ_Pin.AnalogIn.AD6);
            myADC.SetLinearScale(0, 3300);


            DispatcherTimer timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0, 0, 0, 0, 25);
            timer.Tick += new EventHandler(timer_Tick);
            timer.Start();


            return mainWindow;
        }

        void myLED_Click(object sender, EventArgs e)
        {

            if (myLED.Read())
            {
                myLED.Write(false);
            }
            else
            {
                myLED.Write(true);
            }
        }

        private void OnButtonUp(object sender, RoutedEventArgs evt)
        {
            ButtonEventArgs e = (ButtonEventArgs)evt;

            // Print the button code to the Visual Studio output window.
            Debug.Print(e.Button.ToString());

            if (e.Button == Button.VK_SELECT)
            {
                if (!mySW)
                {
                    myText.TextContent = "Interrupt Toggle 1";
                    mySW = true;
                }
                else
                {
                    myText.TextContent = "Interrupt Toggle 2";
                    mySW = false;
                }
            }
        }

        void timer_Tick(object sender, EventArgs e)
        {
            UInt16[] sampleData = new UInt16[10];
            ADC6Text.TextContent = "ADC6:  " + myADC.Read().ToString();
        }


    }
}
