﻿//EX1502_SD2
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;
using System.IO;
using Microsoft.SPOT.IO;
using System.Text;

namespace EX1502_SD2
{
    public class Program
    {
        public static void Main()
        {
            OutputPort led = new OutputPort(Pins.ONBOARD_LED, false);

            RemovableMedia.Eject += new EjectEventHandler(RemovableMedia_Eject);
            RemovableMedia.Insert += new InsertEventHandler(RemovableMedia_Insert);

            var fileName = Path.Combine("\\SD\\", "test1.txt");
            Debug.Print(fileName);
            byte[] writeBytes = Encoding.UTF8.GetBytes("Message to be saved");
            File.WriteAllBytes(fileName, writeBytes);

            Thread.Sleep(100);

            byte[] readBytes = File.ReadAllBytes(fileName);
            Char[] charBuff = UTF8Encoding.UTF8.GetChars(readBytes);
            string sResult = new string(charBuff);
            Debug.Print(sResult);

            var fileName2 = Path.Combine("\\SD\\", "test2.txt");
            Debug.Print(fileName2);
            sResult += "  and more data to be saved";
            byte[] newDataBytes = Encoding.UTF8.GetBytes(sResult);
            File.WriteAllBytes(fileName2, newDataBytes);


            while (true)
            {
                led.Write(true);
                Thread.Sleep(250);
                led.Write(false);
                Thread.Sleep(250);
            }
        }

        static void RemovableMedia_Insert(object sender, MediaEventArgs e)
        {
            Debug.Print("Media inserted");
            VolumeInfo myvol = new VolumeInfo("SD");
            Debug.Print("Volume Name:      " + myvol.Name.ToString());
            Debug.Print("Total size:       " + myvol.TotalSize.ToString());
            Debug.Print("Total Free Space: " + myvol.TotalFreeSpace.ToString());
            Debug.Print("File System:      " + myvol.FileSystem.ToString());
            Debug.Print("Serial number:    " + myvol.SerialNumber.ToString());
            Debug.Print("Volume ID:        " + myvol.VolumeID.ToString());
            Debug.Print("Volume Name:      " + myvol.VolumeLabel.ToString());

        }

        static void RemovableMedia_Eject(object sender, MediaEventArgs e)
        {
            Debug.Print("Media Ejected");
        }

    }
}
