﻿//EX1503_FileStream_FEZPandaII
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Microsoft.SPOT.IO;
using System.IO;
using System.Text;
using GHIElectronics.NETMF.FEZ;
using GHIElectronics.NETMF.IO;

namespace EX1503_FileStream_FEZPandaII
{
    public class Program
    {
        public static void Main()
        {

            PersistentStorage mySD = new PersistentStorage("SD");
            mySD.MountFileSystem();

            var fileName = Path.Combine("\\SD\\", "FileStream.txt");
            Debug.Print(fileName);

            StreamWriter fileLog = new StreamWriter(fileName);
            fileLog.WriteLine("This is a test of the Stream Writer class");
            fileLog.WriteLine("You can write strings directly to the file without byte conversion");
            fileLog.WriteLine("Nice way to store data");
            fileLog.WriteLine("");

            VolumeInfo myvol = new VolumeInfo("SD");
            fileLog.WriteLine("Here is the disk information:");
            fileLog.WriteLine("Volume Name:      " + myvol.Name.ToString());
            fileLog.WriteLine("Total size:       " + myvol.TotalSize.ToString());
            fileLog.WriteLine("Total Free Space: " + myvol.TotalFreeSpace.ToString());
            fileLog.WriteLine("File System:      " + myvol.FileSystem.ToString());
            fileLog.WriteLine("Serial number:    " + myvol.SerialNumber.ToString());
            fileLog.WriteLine("Volume ID:        " + myvol.VolumeID.ToString());
            fileLog.WriteLine("Volume Name:      " + myvol.VolumeLabel.ToString());

            fileLog.Flush();
            fileLog.Close();
            Debug.Print("File saved");
            
            // Blink board LED

            bool ledState = false;

            OutputPort led = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, ledState);

            while (true)
            {
                // Sleep for 500 milliseconds
                Thread.Sleep(500);

                // toggle LED state
                ledState = !ledState;
                led.Write(ledState);
            }
        }

    }
}
