﻿//EX1503_FileStream
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;
using System.IO;
using Microsoft.SPOT.IO;
using System.Text;

namespace EX1503_FileStream
{
    public class Program
    {
        public static void Main()
        {
            OutputPort led = new OutputPort(Pins.ONBOARD_LED, false);

            RemovableMedia.Eject += new EjectEventHandler(RemovableMedia_Eject);
            RemovableMedia.Insert += new InsertEventHandler(RemovableMedia_Insert);

            var fileName = Path.Combine("\\SD\\", "FileStream.txt");
            Debug.Print(fileName);

            StreamWriter fileLog = new StreamWriter(fileName);
            fileLog.WriteLine("This is a test of the Stream Writer class");
            fileLog.WriteLine("You can write strings directly to the file without byte conversion");
            fileLog.WriteLine("Nice way to store data");
            fileLog.WriteLine("");

            VolumeInfo myvol = new VolumeInfo("SD");
            fileLog.WriteLine("Here is the disk information:");
            fileLog.WriteLine("Volume Name:      " + myvol.Name.ToString());
            fileLog.WriteLine("Total size:       " + myvol.TotalSize.ToString());
            fileLog.WriteLine("Total Free Space: " + myvol.TotalFreeSpace.ToString());
            fileLog.WriteLine("File System:      " + myvol.FileSystem.ToString());
            fileLog.WriteLine("Serial number:    " + myvol.SerialNumber.ToString());
            fileLog.WriteLine("Volume ID:        " + myvol.VolumeID.ToString());
            fileLog.WriteLine("Volume Name:      " + myvol.VolumeLabel.ToString());

            fileLog.Flush();
            fileLog.Close();
            Debug.Print("File saved");


            while (true)
            {
                led.Write(true);
                Thread.Sleep(250);
                led.Write(false);
                Thread.Sleep(250);
            }
        }


        static void RemovableMedia_Insert(object sender, MediaEventArgs e)
        {
            Debug.Print("Media inserted");
        }

        static void RemovableMedia_Eject(object sender, MediaEventArgs e)
        {
            Debug.Print("Media Ejected");
        }
    }
}
