﻿//
//EX1601_StorageEWR
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using System.Threading;

namespace EX1601_StorageEWR
{
    public class Program
    {
        public static void Main()
        {
            Debug.Print(Resources.GetString(Resources.StringResources.String1));
            App myApp = new App();
            myApp.Run();
        }

        public class App
        {

            //Define the EWR
            private static ExtendedWeakReference myData;

            //Define the class, flag or file name that is unique for the data
            private static class TypeAppDataFlag { }

            //The data were are saving
            [Serializable]
            private sealed class theData
            {

                public Int32 BootCount;
                public String theDataString;

                public void newData(string theString)
                {
                    theDataString = theString;
                }

                public void newBootCount(Int32 bootCount)
                {
                    BootCount = bootCount;
                }
            }

            private static theData myStoredData;

            public static void GetData()
            {

                myData = ExtendedWeakReference.RecoverOrCreate(typeof(TypeAppDataFlag), 0, ExtendedWeakReference.c_SurvivePowerdown);
                myData.Priority = (Int32)ExtendedWeakReference.PriorityLevel.Important;

                myStoredData = myData.Target as theData;

                if (myStoredData == null)
                {
                    Debug.Print("First Boot or data was lost");
                    myStoredData = new theData();
                    myStoredData.newBootCount(0);
                    myStoredData.newData("New");

                }

            }

            public static void SaveData()
            {
                myData.Target = myStoredData;
                Thread.Sleep(4000);
            }

            public void Run()
            {
                //Load the old data from flash
                GetData();


                Debug.Print("Number of boots is " + myStoredData.BootCount);
                Debug.Print(myStoredData.theDataString);

                //Manipulate the data
                myStoredData.BootCount++;
                if (myStoredData.theDataString == "String A")
                {
                    myStoredData.newData("String B");
                }
                else if (myStoredData.theDataString == "String B" || myStoredData.theDataString == "New")
                {
                    myStoredData.newData("String A");

                }
                Debug.Print("The new data to be saved:");
                Debug.Print("Boot number is " + myStoredData.BootCount);
                Debug.Print(myStoredData.theDataString);

                //Save the updates
                SaveData();
                Debug.Print("Data Saved!");

            }

        }

    }
}
