﻿//Button_LED_Test
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;

namespace Button_LED_Test
{
    public class Program
    {
        public static void Main()
        {
            // Blink board LED

            bool ledState = false;
            OutputPort led = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, ledState);


            InterruptPort SW1 = new InterruptPort((Cpu.Pin)FEZ_Pin.Digital.IO19, true, Port.ResistorMode.PullUp, Port.InterruptMode.InterruptEdgeHigh);
            InterruptPort SW2 = new InterruptPort((Cpu.Pin)FEZ_Pin.Digital.IO18, true, Port.ResistorMode.PullUp, Port.InterruptMode.InterruptEdgeHigh);
            InterruptPort SW3 = new InterruptPort((Cpu.Pin)FEZ_Pin.Digital.IO17, true, Port.ResistorMode.PullUp, Port.InterruptMode.InterruptEdgeHigh);

            SW1.OnInterrupt += new NativeEventHandler(SW1_OnInterrupt);
            SW2.OnInterrupt += new NativeEventHandler(SW2_OnInterrupt);
            SW3.OnInterrupt += new NativeEventHandler(SW3_OnInterrupt);


            while (true)
            {
                // Sleep for 500 milliseconds
                Thread.Sleep(500);

                // toggle LED state
                ledState = !ledState;
                led.Write(ledState);
            }
        }

        public static OutputPort LED1 = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.IO22, false);
        public static OutputPort LED2 = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.IO21, false);
        public static OutputPort LED3 = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.IO20, false);



        static void SW3_OnInterrupt(uint data1, uint data2, DateTime time)
        {
            LED3.Write(!LED3.Read());
        }

        static void SW2_OnInterrupt(uint data1, uint data2, DateTime time)
        {
            LED2.Write(!LED2.Read());
        }

        static void SW1_OnInterrupt(uint data1, uint data2, DateTime time)
        {
            LED1.Write(!LED1.Read());
        }

    }
}
