﻿//GPS
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;

using SJJEMS.ParallaxGPS;

namespace GPS_Test
{
    public class Program
    {
        public static void Main()
        {
            App myApp = new App();
            myApp.Run();
        }

    }

    public class App
    {
        ParallaxGPS myGPS = new ParallaxGPS();

        public void Run()
        {

            myGPS.ParallaxGPSInitialize("COM2");

            while (true)
            {

                Debug.Print("Firmware = " + myGPS.GetFirmwareVersion());
                Debug.Print("Hardware = " + myGPS.GetHardwareVersion());
                Debug.Print("Valid Signal = " + myGPS.GetValid().ToString());
                Debug.Print("Satelites = " + myGPS.GetSats());
                Debug.Print("Time = " + myGPS.GetTime());
                Debug.Print("Date = " + myGPS.GetDate());
                Debug.Print("Lat = " + myGPS.GetLat());
                Debug.Print("Lat Decimal = " + myGPS.GetLatDecimal().ToString());
                Debug.Print("Long = " + myGPS.GetLong());
                Debug.Print("Long Decimal = " + myGPS.GetLongDecimal().ToString());
                Debug.Print("Altitude = " + myGPS.GetAlt());
                Debug.Print("Speed = " + myGPS.GetSpeed());
                Debug.Print("Heading = " + myGPS.GetHeading());

                Thread.Sleep(100);
            }


        }




    }


}
