﻿//SPI_LCD_4x20_Test
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;
using Microsoft.SPOT.Hardware.SJJ.SPI_LCD_DRIVER;
using Microsoft.SPOT.Hardware.SJJ.SPI_LCD_4x20_Extension_Driver;


namespace SPI_LCD_4x20_Test
{
    public class Program
    {

        public static SPI mySPIPort;
        
        public static void Main()
        {
            // Blink board LED
            bool ledState = false;
            OutputPort led = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, ledState);

            SPI.Configuration mySPIPortConfig = new SPI.Configuration((Cpu.Pin)FEZ_Pin.Digital.IO50, false, 0, 0, false, true, 50, SPI.SPI_module.SPI1);
            mySPIPort = new SPI(mySPIPortConfig);
            SPI_LCD_4x20_Driver mySPILCD = new SPI_LCD_4x20_Driver();

            SPIWriteLoop(mySPILCD.LCDClear());
            Thread.Sleep(6);

            SPIWriteLoop(mySPILCD.LCDBacklightOn());
            Thread.Sleep(6);

            SPIWriteLoop(mySPILCD.LCDHomeCursor());
            Thread.Sleep(6);

            SPIWriteLoop(mySPILCD.LCDBlinkblockCursorOff());
            Thread.Sleep(6);

            SPIWriteLoop(mySPILCD.LCD4LLineNoWrap("This is a test", 1));
            Thread.Sleep(6);
            SPIWriteLoop(mySPILCD.LCD4LLineNoWrap("of the 4x20 display", 2));
            Thread.Sleep(6);
            SPIWriteLoop(mySPILCD.LCD4LLineNoWrap("4 Lines to write too", 3));
            Thread.Sleep(6);
            SPIWriteLoop(mySPILCD.LCD4LLineNoWrap("More info to display", 4));
            Thread.Sleep(6);
            
            while (true)
            {
                // Sleep for 500 milliseconds
                Thread.Sleep(500);

                // toggle LED state
                ledState = !ledState;
                led.Write(ledState);
            }
        }


        public static void SPIWriteLoop(byte[] bWriteMessage)
        {

            byte[] Xfer = new byte[1];

            for (int i = 0; i < bWriteMessage.Length; i++)
            {
                Xfer[0] = bWriteMessage[i];
                mySPIPort.Write(Xfer);
            }
        }

    }
}
