﻿//Stinger
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;

using SJJEMS.RobotSerializer;

namespace Stinger
{
    public class Program
    {
        public static void Main()
        {
            App myApp = new App();
            myApp.Run();
        }
    }

    public class App
    {

        RobotSerializer myRobot = new RobotSerializer();
        OutputPort myLED = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, false);
        public int ReverseCheck = 0;
        public int sensor_Senstivity = 200;


        public void Run()
        {

            myRobot.RobotInitialize("COM1");
            

            while (true)
            {
                myRobot.RobotMove(10, 10);
                Scan();            
                Thread.Sleep(100);
            }

        }

        public void Scan()
        {
            bool ScanLeft = false;
            bool ScanCenter = false;
            bool ScanRight = false;

            if (myRobot.RobotSensor(0) > sensor_Senstivity)
            {
                ScanLeft = true;
                myRobot.RobotStop();
                myLED.Write(true);
            }
            if (myRobot.RobotSensor(1) > sensor_Senstivity)
            {
                ScanCenter = true;
                myRobot.RobotStop();
                myLED.Write(true);
            }
            if (myRobot.RobotSensor(2) > sensor_Senstivity)
            {
                ScanRight = true;
                myRobot.RobotStop();
                myLED.Write(true);
            }

            if (ScanLeft == true && ScanCenter == true && ScanRight == true)
            {
                //Obstruction ahead - turn around
                myRobot.RobotMove(-10, -10);
                Thread.Sleep(500);
                myRobot.RobotStop();
                ReverseCheck += 1;
                Reversechecking();
                Scan();
            }
            else if (ScanLeft == true && ScanCenter == true && ScanRight == false)
            {
                //turn right
                myRobot.RobotMove(-12, 12);     
                Thread.Sleep(1000);
                myRobot.RobotStop();
            }
            else if (ScanLeft == true && ScanCenter == false && ScanRight == true)
            {
                //Obstruction ahead - turn around
                myRobot.RobotMove(-10, -10);
                Thread.Sleep(500);
                myRobot.RobotStop();
                ReverseCheck += 1;
                Reversechecking();
                Scan();
            }
            else if (ScanLeft == false && ScanCenter == true && ScanRight == true)
            {
                //Turn Left
                myRobot.RobotMove(12, -12);
                Thread.Sleep(1000);
                myRobot.RobotStop();
            }
            else if (ScanLeft == false && ScanCenter == false && ScanRight == true)
            {
                //Turn Left
                myRobot.RobotMove(12, -12);
                Thread.Sleep(500);
                myRobot.RobotStop();
            }
            else if (ScanLeft == true && ScanCenter == false && ScanRight == false)
            {
                //turn right
                myRobot.RobotMove(-12, 12);
                Thread.Sleep(500);
                myRobot.RobotStop();
            }
            else if (ScanLeft == false && ScanCenter == false && ScanRight == false)
            {
                myRobot.RobotMove(10, 10);
                Thread.Sleep(500);
            }
            else if (ScanLeft == false && ScanCenter == true && ScanRight == false)
            {
                //Obstruction ahead - turn around
                myRobot.RobotMove(-10, -10);
                Thread.Sleep(500);
                myRobot.RobotStop();
                ReverseCheck += 1;
                Reversechecking();
                Scan();
            }
                       
            myLED.Write(false);
        }


        public void Reversechecking()
        {
                        
            if (ReverseCheck >= 2)
            {                
                //Spin around Right
                myRobot.RobotMove(-12, 12);
                Thread.Sleep(1800);
                myRobot.RobotStop();
                ReverseCheck = 0;
            }

        }

    }

}
