﻿//Temp_Sensor
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;
using SJJEMS.RobotSerializer;

namespace Temp_Sensor_Test
{
    public class Program
    {
        public static void Main()
        {
            // Blink board LED
            bool ledState = false;
            OutputPort led = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, ledState);

            RobotSerializer myRobot = new RobotSerializer();
            myRobot.RobotInitialize("COM1");

            int tempValue = myRobot.RobotSensor(4);
            float tempC = ((((float)tempValue * 5) / 1024) * 100) - 273;
            float tempF = (tempC * (float)1.8) + 32;         

            while (true)
            {

                Debug.Print("Temp: " + tempF.ToString() + "F / " + tempC.ToString() + "C");
                // Sleep for 500 milliseconds
                Thread.Sleep(500);

                // toggle LED state
                ledState = !ledState;
                led.Write(ledState);
                Thread.Sleep(500);

                tempValue = myRobot.RobotSensor(4);
                tempC = ((((float)tempValue * 5) / 1024) * 100) - 273;
                tempF = (tempC * (float)1.8) + 32;

            }
        }

    }
}
