﻿//
//Block_GPIO_Driver
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Microsoft.SPOT.Hardware.SJJ;

namespace Microsoft.SPOT.Hardware.SJJ.Block_GPIO_Driver
{
    public class Block_GPIO_Driver
    {


        # region PW_GPIO

        InputPort PW0 = new InputPort(Pins.GPIO_PORT_W_0, false, Port.ResistorMode.Disabled);
        InputPort PW1 = new InputPort(Pins.GPIO_PORT_W_1, false, Port.ResistorMode.Disabled);
        InputPort PW2 = new InputPort(Pins.GPIO_PORT_W_2, false, Port.ResistorMode.Disabled);
        InputPort PW3 = new InputPort(Pins.GPIO_PORT_W_3, false, Port.ResistorMode.Disabled);
        InputPort PW4 = new InputPort(Pins.GPIO_PORT_W_4, false, Port.ResistorMode.Disabled);
        InputPort PW5 = new InputPort(Pins.GPIO_PORT_W_5, false, Port.ResistorMode.Disabled);
        InputPort PW6 = new InputPort(Pins.GPIO_PORT_W_6, false, Port.ResistorMode.Disabled);
        InputPort PW7 = new InputPort(Pins.GPIO_PORT_W_7, false, Port.ResistorMode.Disabled);
        

        public int PW_Input()
        {

            int PW = 0;

            if (PW0.Read())
            {
                PW |= 1;
            }
            if (PW1.Read())
            {
                PW |= 2;
            }
            if (PW2.Read())
            {
                PW |= 4;
            }
            if (PW3.Read())
            {
                PW |= 8;
            }
            if (PW4.Read())
            {
                PW |= 0x10;
            }
            if (PW5.Read())
            {
                PW |= 0x20;
            }
            if (PW6.Read())
            {
                PW |= 0x40;
            }
            if (PW7.Read())
            {
                PW |= 0x80;
            }

            return PW;

        }
        # endregion //PW_GPIO

        # region PZ_GPIO

        InputPort PZ0 = new InputPort(Pins.GPIO_PORT_Z_0, false, Port.ResistorMode.Disabled);
        InputPort PZ1 = new InputPort(Pins.GPIO_PORT_Z_1, false, Port.ResistorMode.Disabled);
        InputPort PZ2 = new InputPort(Pins.GPIO_PORT_Z_2, false, Port.ResistorMode.Disabled);
        InputPort PZ3 = new InputPort(Pins.GPIO_PORT_Z_3, false, Port.ResistorMode.Disabled);
        InputPort PZ4 = new InputPort(Pins.GPIO_PORT_Z_4, false, Port.ResistorMode.Disabled);
        InputPort PZ5 = new InputPort(Pins.GPIO_PORT_Z_5, false, Port.ResistorMode.Disabled);
        InputPort PZ6 = new InputPort(Pins.GPIO_PORT_Z_6, false, Port.ResistorMode.Disabled);
        InputPort PZ7 = new InputPort(Pins.GPIO_PORT_Z_7, false, Port.ResistorMode.Disabled);

        public int PZ_Input()
        {

            int PZ = 0;

            if (PZ0.Read())
            {
                PZ |= 1;
            }
            if (PZ1.Read())
            {
                PZ |= 2;
            }
            if (PZ2.Read())
            {
                PZ |= 4;
            }
            if (PZ3.Read())
            {
                PZ |= 8;
            }
            if (PZ4.Read())
            {
                PZ |= 0x10;
            }
            if (PZ5.Read())
            {
                PZ |= 0x20;
            }
            if (PZ6.Read())
            {
                PZ |= 0x40;
            }
            if (PZ7.Read())
            {
                PZ |= 0x80;
            }

            return PZ;
        }

        # endregion //PZ_GPIO

        # region PY_GPIO
        OutputPort PY0 = new OutputPort(Pins.GPIO_PORT_Y_0, false);
        OutputPort PY1 = new OutputPort(Pins.GPIO_PORT_Y_1, false);
        OutputPort PY2 = new OutputPort(Pins.GPIO_PORT_Y_2, false);
        OutputPort PY3 = new OutputPort(Pins.GPIO_PORT_Y_3, false);
        OutputPort PY4 = new OutputPort(Pins.GPIO_PORT_Y_4, false);
        OutputPort PY5 = new OutputPort(Pins.GPIO_PORT_Y_5, false);
        OutputPort PY6 = new OutputPort(Pins.GPIO_PORT_Y_6, false);
        OutputPort PY7 = new OutputPort(Pins.GPIO_PORT_Y_7, false);

        public void PY_Output(int PY)
        {

            if ((PY & 1) > 0)
            {
                PY0.Write(true);
            }
            else
            {
                PY0.Write(false);
            }

            if (((PY >> 1) & 1) > 0)
            {
                PY1.Write(true);
            }
            else
            {
                PY1.Write(false);
            }

            if (((PY >> 2) & 1) > 0)
            {
                PY2.Write(true);
            }
            else
            {
                PY2.Write(false);
            }

            if (((PY >> 3) & 1) > 0)
            {
                PY3.Write(true);
            }
            else
            {
                PY3.Write(false);
            }

            if (((PY >> 4) & 1) > 0)
            {
                PY4.Write(true);
            }
            else
            {
                PY4.Write(false);
            }

            if (((PY >> 5) & 1) > 0)
            {
                PY5.Write(true);
            }
            else
            {
                PY5.Write(false);
            }

            if (((PY >> 6) & 1) > 0)
            {
                PY6.Write(true);
            }
            else
            {
                PY6.Write(false);
            }

            if (((PY >> 7) & 1) > 0)
            {
                PY7.Write(true);
            }
            else
            {
                PY7.Write(false);
            }

        }



        # endregion //PY_GPIO

        # region PX_GPIO
        OutputPort PX0 = new OutputPort(Pins.GPIO_PORT_X_0, false);
        OutputPort PX1 = new OutputPort(Pins.GPIO_PORT_X_1, false);
        OutputPort PX2 = new OutputPort(Pins.GPIO_PORT_X_2, false);
        OutputPort PX3 = new OutputPort(Pins.GPIO_PORT_X_3, false);
        OutputPort PX4 = new OutputPort(Pins.GPIO_PORT_X_4, false);
        OutputPort PX5 = new OutputPort(Pins.GPIO_PORT_X_5, false);
        OutputPort PX6 = new OutputPort(Pins.GPIO_PORT_X_6, false);
        OutputPort PX7 = new OutputPort(Pins.GPIO_PORT_X_7, false);

        public void PX_Output(int PX)
        {

            if ((PX & 1) > 0)
            {
                PX0.Write(true);
            }
            else
            {
                PX0.Write(false);
            }

            if (((PX >> 1) & 1) > 0)
            {
                PX1.Write(true);
            }
            else
            {
                PX1.Write(false);
            }

            if (((PX >> 2) & 1) > 0)
            {
                PX2.Write(true);
            }
            else
            {
                PX2.Write(false);
            }

            if (((PX >> 3) & 1) > 0)
            {
                PX3.Write(true);
            }
            else
            {
                PX3.Write(false);
            }

            if (((PX >> 4) & 1) > 0)
            {
                PX4.Write(true);
            }
            else
            {
                PX4.Write(false);
            }

            if (((PX >> 5) & 1) > 0)
            {
                PX5.Write(true);
            }
            else
            {
                PX5.Write(false);
            }

            if (((PX >> 6) & 1) > 0)
            {
                PX6.Write(true);
            }
            else
            {
                PX6.Write(false);
            }

            if (((PX >> 7) & 1) > 0)
            {
                PX7.Write(true);
            }
            else
            {
                PX7.Write(false);
            }

        }




        # endregion //PX_GPIO

        



    }
}
