﻿//
//EX602_BasicIO
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Microsoft.SPOT.Hardware.SJJ;
using System.Threading;


namespace EX602_BasicIO_EDK
{
    public class Program
    {
        public static void Main()
        {
            Debug.Print(
                Resources.GetString(Resources.StringResources.String1));

            App myApp = new App();
            myApp.Run();

        }

    }

    public class App
    {
        OutputPort myPY7;
        InputPort myHGPIO2;
        OutputPort myGreenLED;

        public void Run()
        {
            //Connect a jumper wire between PY7 and HGPIO2
            myPY7 = new OutputPort(Pins.GPIO_PORT_Y_7, false);
            myHGPIO2 = new InputPort(Pins.HGPIO2_HDR3_1, false, Port.ResistorMode.Disabled);
            myGreenLED = new OutputPort(Pins.GREEN_LED, false);

            while (true)
            {

                Thread.Sleep(500);
                myPY7.Write(true);

                Thread.Sleep(10);

                myGreenLED.Write(myHGPIO2.Read());

                Thread.Sleep(10);

                myPY7.Write(false);

                Thread.Sleep(10);

                myGreenLED.Write(myHGPIO2.Read());


            }

        }
    }
}
