﻿//EX604_Interrupt_EDK
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using Microsoft.SPOT.Hardware.SJJ;
using System.Threading;

namespace EX604_Interrupt_EDK
{
    public class Program
    {
        public static void Main()
        {
            App myApp = new App();
            myApp.Run();            
        }
    }

    public class App
    {

        public bool Int_SW = true;

        OutputPort GREEN_LED = new OutputPort(Pins.GREEN_LED, false);
        InterruptPort EGPIO1 = new InterruptPort(Pins.EGPIO1_HDR3_13_CLK1_HZ, true, Port.ResistorMode.Disabled, Port.InterruptMode.InterruptEdgeLow);

        public void Run()
        {
            EGPIO1.OnInterrupt += new NativeEventHandler(EGPIO1_OnInterrupt);

            while (true)
            {
                if (Int_SW == true)
                {
                    GREEN_LED.Write(true);
                    Thread.Sleep(500);
                    GREEN_LED.Write(false);
                    Thread.Sleep(500);
                }
                else
                {
                    GREEN_LED.Write(false);
                    Thread.Sleep(500);
                }
            }
        }

        void EGPIO1_OnInterrupt(uint data1, uint data2, DateTime time)
        {
            if (Int_SW == true)
            {
                Int_SW = false;
            }
            else
            {
                Int_SW = true;
            }
        }
    }
}
