﻿//EX604_Interrupt_FEZ_Panda_II
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;

namespace EX604_Interrupt_FEZ_Panda_II
{
    public class Program
    {
            public static void Main()
            {
                App myApp = new App();
                myApp.Run();
            }

    }

    public class App
    {

        public bool Int_SW = true;

        OutputPort myRED_LED = new OutputPort((Cpu.Pin)FEZ_Pin.Digital.LED, false);
        InterruptPort swLDR = new InterruptPort((Cpu.Pin)FEZ_Pin.Digital.LDR, true, Port.ResistorMode.PullUp, Port.InterruptMode.InterruptEdgeHigh);
        
        public void Run()
        {

            swLDR.OnInterrupt += new NativeEventHandler(swLDR_OnInterrupt);

            while (true)
            {

                if (Int_SW == true)
                {
                    myRED_LED.Write(true);
                    Thread.Sleep(500);
                    myRED_LED.Write(false);
                    Thread.Sleep(500);
                }
                else
                {
                    myRED_LED.Write(false);
                    Thread.Sleep(500);
                }
            }
        }

        void swLDR_OnInterrupt(uint data1, uint data2, DateTime time)
        {
            if (Int_SW == true)
            {
                Int_SW = false;
            }
            else
            {
                Int_SW = true;
            }
        }
    }
}
