﻿//EX604_Interrupt_Meridian
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using DeviceSolutions.SPOT.Hardware;
using Microsoft.SPOT.Hardware;
using System.Threading;


namespace EX604_Interrupt_MedianP
{
    public class Program
    {
        public static void Main()
        {
            APP myApp = new APP();
            myApp.Run();
        }
    }

    public class APP
    {

        public bool Int_SW = true;

        OutputPort RED_LED = new OutputPort(MeridianP.Pins.LED, false);
        InterruptPort SW1 = new InterruptPort(MeridianP.Pins.SW1, true, Port.ResistorMode.Disabled, Port.InterruptMode.InterruptEdgeHigh);

        public void Run()
        {

            SW1.OnInterrupt += new NativeEventHandler(SW1_OnInterrupt);
            while (true)
            {
                if (Int_SW == true)
                {
                    RED_LED.Write(true);
                    Thread.Sleep(500);
                    RED_LED.Write(false);
                    Thread.Sleep(500);
                }
                else
                {
                    RED_LED.Write(false);
                    Thread.Sleep(500);
                }
            } 
        }

        void SW1_OnInterrupt(uint data1, uint data2, DateTime time)
        {

            if (Int_SW == true)
            {
                Int_SW = false;
            }
            else
            {
                Int_SW = true;
            }
        }
    }
}
