﻿//EX606_InterruptLatency_EDK
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using System.Threading;
using Microsoft.SPOT.Hardware.SJJ;

namespace EX606_InterruptLatency_EDK
{
    public class Program
    {
        public static void Main()
        {
            Debug.Print(Resources.GetString(Resources.StringResources.String1));
            App myApp = new App();
            myApp.Run();
        }

        public class App
        {

            static bool bGPIOOutState = false;

            InterruptPort FGPIO1 = new InterruptPort(Pins.FGPIO1_HDR3_9, true, Port.ResistorMode.Disabled, Port.InterruptMode.InterruptEdgeHigh);
            OutputPort EGPIO10 = new OutputPort(Pins.EGPIO10_HDR3_21, false);
            OutputPort GREEN_LED = new OutputPort(Pins.GREEN_LED, false);

            public void Run()
            {

                FGPIO1.OnInterrupt += new NativeEventHandler(FGPIO1_OnInterrupt);

                while (true)
                {
                    GREEN_LED.Write(true);
                    Thread.Sleep(500);
                    GREEN_LED.Write(false);
                    Thread.Sleep(500);
                }
            }

            void FGPIO1_OnInterrupt(uint data1, uint data2, DateTime time)
            {
                if (bGPIOOutState)
                {
                    bGPIOOutState = false;
                }
                else
                {
                    bGPIOOutState = true;
                }

                EGPIO10.Write(bGPIOOutState);
            }
        }
    }
}
