﻿//EX606_InterruptLatency_MeridianP
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using DeviceSolutions.SPOT.Hardware;
using System.Threading;

namespace EX606_InterruptLatency_MeridianP
{
    public class Program
    {
        public static void Main()
        {
            App myApp = new App();
            myApp.Run();
        }
    }

    public class App
    {

        static bool bGPIOOutState = false;
        InterruptPort GPIO1 = new InterruptPort(MeridianP.Pins.GPIO1, true, Port.ResistorMode.Disabled, Port.InterruptMode.InterruptEdgeHigh);
        OutputPort GPIO7 = new OutputPort(MeridianP.Pins.GPIO7, false);
        OutputPort RED_LED = new OutputPort(MeridianP.Pins.LED, false);

        public void Run()
        {

            GPIO1.OnInterrupt += new NativeEventHandler(GPIO1_OnInterrupt);

            while (true)
            {
                RED_LED.Write(true);
                Thread.Sleep(500);
                RED_LED.Write(false);
                Thread.Sleep(500);
            }
        }

        void GPIO1_OnInterrupt(uint data1, uint data2, DateTime time)
        {
            if (bGPIOOutState)
            {
                bGPIOOutState = false;
            }
            else
            {
                bGPIOOutState = true;
            }
            GPIO7.Write(bGPIOOutState);
        }
    }
}
