﻿//EX701_Serial_EDK
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using System.Threading;
using Microsoft.SPOT.Hardware.SJJ;
using System.IO.Ports;
using System.Text;

namespace EX701_Serial_EDK
{
    public class Program
    {
        public static void Main()
        {

            Debug.Print(Resources.GetString(Resources.StringResources.String1));
            App myApp = new App();
            myApp.Run();
        }

        public class App
        {

            public SerialPort COM2Port = new SerialPort(SerialPorts.COM2, (int)BaudRates.Baud115200, Parity.None, 8);
            public static String sOutput = "Outputting to COM2\n";
            public byte[] boutArray = new byte[sOutput.Length];
            public OutputPort myGreenLED = new OutputPort(Pins.GREEN_LED, false);
            

            public void Run()
            {
                COM2Port.ReadTimeout = 10;
                COM2Port.Open();

                //The Data Received event must come after the COM port open call
                COM2Port.DataReceived += new SerialDataReceivedEventHandler(COM2Port_DataReceived);


                System.Text.UTF8Encoding Encoding = new System.Text.UTF8Encoding();
                boutArray = Encoding.GetBytes(sOutput);

                COM2Port.Write(boutArray, 0, boutArray.Length);
                Thread.Sleep(500);

                //Stay in loop to continue to receive data
                while (true)
                {
                    Thread.Sleep(500);
                    myGreenLED.Write(true);

                    Thread.Sleep(500);
                    myGreenLED.Write(false);
                }

            }

            void COM2Port_DataReceived(object sender, SerialDataReceivedEventArgs e)
            {
                int incount;
                int iBytesToRead;

                if ((iBytesToRead = COM2Port.BytesToRead) > 0)
                {
                    byte[] binArray = new byte[iBytesToRead];

                    incount = COM2Port.Read(binArray, 0, iBytesToRead);
                    COM2Port.Write(binArray, 0, incount);

                }
            }
        }
    }
}
