﻿//EX801_SPILCD_EDK
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//


using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using System.Threading;
using Microsoft.SPOT.Hardware.SJJ;

namespace EX801_SPILCD_EDK
{
    public class Program
    {
        public static void Main()
        {

            Debug.Print(Resources.GetString(Resources.StringResources.String1));
            App myApp = new App();
            myApp.Run();
        }

        public class App
        {

            static SPI.Configuration mySPIPortSettings = new SPI.Configuration(Pins.GPIO_NONE, false, 0, 0, false, true, 300, SPI.SPI_module.SPI1);
            SPI mySPIPort = new SPI(mySPIPortSettings);

            public void Run()
            {
                // LCD send byte string to lines preamble
                byte[] bWriteLCDLine1Preamble = new byte[] { 0xF5, 0x8A, 0x01, 0x01, 0xF5, 0x80 };

                // Unicode literal strings
                string sDisplayString1 = "Welcome to .NET MF";

                // Convert string literals to byte arrays
                byte[] bDisplayString1 = new byte[sDisplayString1.Length];

                // convert literal unicode strings to byte arrays
                System.Text.UTF8Encoding Encoding = new System.Text.UTF8Encoding();
                bDisplayString1 = Encoding.GetBytes(sDisplayString1);

                // Construct the final message byte array
                byte[] bWriteMessageLine1 = new byte[bWriteLCDLine1Preamble.Length + bDisplayString1.Length];

                //copy the preamble for line 1 first followed by the string1 starting at the
                //end of the pre-able (using the length)
                bWriteLCDLine1Preamble.CopyTo(bWriteMessageLine1, 0);
                bDisplayString1.CopyTo(bWriteMessageLine1, bWriteLCDLine1Preamble.Length);

                Thread.Sleep(1000);
                mySPIPort.Write(bWriteMessageLine1);
                Thread.Sleep(6);

            }
        }
    }
}
