﻿//EX802_SPILCD_Netduino
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.Netduino;

namespace EX802_SPILCD_Netduino
{
    public class Program
    {
        public static void Main()
        {
            // write your code here
            SPI.Configuration mySPI = new SPI.Configuration(Pins.GPIO_PIN_D10, false, 0, 0, false, true, 100, SPI.SPI_module.SPI1);
            SPI mySPIPort = new SPI(mySPI);

            // LCD send byte string to lines preamble
            byte[] bWriteLCDLine1Preamble = new byte[] { 0xF5, 0x8A, 0x01, 0x01, 0xF5, 0x80 };
            // Unicode literal strings
            string sDisplayString1 = "Welcome to .NET MF";

            // Convert string literals to byte arrays
            byte[] bDisplayString1 = new byte[sDisplayString1.Length];

            // convert literal unicode strings to byte arrays
            System.Text.UTF8Encoding Encoding = new System.Text.UTF8Encoding();
            bDisplayString1 = Encoding.GetBytes(sDisplayString1);

            // Construct the final message byte array
            byte[] bWriteMessageLine1 = new byte[bWriteLCDLine1Preamble.Length + bDisplayString1.Length];

            //copy the preamble for line 1 first followed by the string1 starting at the
            //end of the pre-able (using the length)
            bWriteLCDLine1Preamble.CopyTo(bWriteMessageLine1, 0);
            bDisplayString1.CopyTo(bWriteMessageLine1, bWriteLCDLine1Preamble.Length);

            Thread.Sleep(1000);

            //Adjustment for continuous burst mode
            byte[] Xfer = new byte[1];

            for (int i = 0; i < bWriteMessageLine1.Length; i++)
            {
                Xfer[0] = bWriteMessageLine1[i];
                mySPIPort.Write(Xfer);
            }
        }
    }
}
