﻿//EX803_SPILCDDRIVER_EDK
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using System.Threading;
using Microsoft.SPOT.Hardware.SJJ;
using Microsoft.SPOT.Hardware.SJJ.SPI_LCD_DRIVER;

namespace EX803_SPILCDDRIVER_EDK
{
    public class Program
    {
        public static void Main()
        {
            Debug.Print(Resources.GetString(Resources.StringResources.String1));
            App myApp = new App();
            myApp.Run();
        }

        public class App
        {
            static SPI.Configuration mySPIPortSettings = new SPI.Configuration(Pins.GPIO_NONE, false, 0, 0, false, true, 50, SPI.SPI_module.SPI1);
            SPI mySPIPort = new SPI(mySPIPortSettings);
            SPI_LCDDriver myLCDDriver = new SPI_LCDDriver();

            public void Run()
            {

                //Turn backlight off
                mySPIPort.Write(myLCDDriver.LCDBacklightOff());
                Thread.Sleep(100);

                //Clear display
                mySPIPort.Write(myLCDDriver.LCDClear());
                Thread.Sleep(6);

                //Home cursor
                mySPIPort.Write(myLCDDriver.LCDHomeCursor());
                Thread.Sleep(6);

                //Turn flashing cursor on
                mySPIPort.Write(myLCDDriver.LCDBlinkblockCursorOn());
                Thread.Sleep(6);

                //Turn backlight on
                mySPIPort.Write(myLCDDriver.LCDBacklightOn());
                Thread.Sleep(10);

                mySPIPort.Write(myLCDDriver.LCDLine1("LCD class"));
                Thread.Sleep(6);

                mySPIPort.Write(myLCDDriver.LCDLine2("driver is fun"));
                Thread.Sleep(3000);

                mySPIPort.Write(myLCDDriver.LCDShiftDisplayUp());
                Thread.Sleep(6);

                mySPIPort.Write(myLCDDriver.LCDLine2("Welcome to .NET MF"));
                Thread.Sleep(6);

                mySPIPort.Write(myLCDDriver.LCDShiftDisplayUp());
                Thread.Sleep(6);

                mySPIPort.Write(myLCDDriver.LCDLine2("www.netmf.com"));
                Thread.Sleep(6);

            }
        }
    }
}
