﻿//EX804_SPIKEYPAD_EDK
//
//SJJ Embedded Micro Solutions
//www.sjjmicro.com / www.seanliming.com
//Copyright (c) 2006-2012 SJJ Embedded Micro Solutions    All Rights Reserved
//
//Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
//liability for direct or indirect consequences arising from the use of this source code. The authors
//and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
//liability for direct or indirect damages of any kind arising from the use of this source code.
//
//The author resrves the right to make changes in this source code without notice and without
//incurring any liability.
//

using System;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using System.Threading;
using Microsoft.SPOT.Hardware.SJJ;
using Microsoft.SPOT.Hardware.SJJ.SPI_LCD_DRIVER;


namespace EX804_SPIKEYPAD_EDK
{
    public class Program
    {
        public static void Main()
        {

            Debug.Print(Resources.GetString(Resources.StringResources.String1));
            App myApp = new App();
            myApp.Run();
        }

        public class App
        {

            static SPI.Configuration mySPIPortSettings = new SPI.Configuration(Pins.GPIO_NONE, false, 0, 0, false, true, 50, SPI.SPI_module.SPI1);
            SPI mySPIPort = new SPI(mySPIPortSettings);
            SPI_LCDDriver myLCDDriver = new SPI_LCDDriver();


            public void Run()
            {
                //Clear display
                mySPIPort.Write(myLCDDriver.LCDClear());
                Thread.Sleep(6);

                //Home cursor
                mySPIPort.Write(myLCDDriver.LCDHomeCursor());
                Thread.Sleep(6);

                //Turn flashing cursor on
                mySPIPort.Write(myLCDDriver.LCDBlinkblockCursorOn());
                Thread.Sleep(6);

                mySPIPort.Write(myLCDDriver.LCDLine1("Keypad Test"));
                Thread.Sleep(1500);


                //Clear display
                mySPIPort.Write(myLCDDriver.LCDClear());
                Thread.Sleep(6);

                //Setup to write the keypad character to LCD
                byte[] bWriteLCDChar = new byte[3];
                bWriteLCDChar[0] = 0xF5;
                bWriteLCDChar[1] = 0x80;

                while (true)
                {

                    mySPIPort.WriteRead(myLCDDriver.LCDKeyPadRead(), myLCDDriver.KeyPadReadBuf);
                    Thread.Sleep(6);

                    if ((myLCDDriver.KeyPadReadBuf[3] >= 0x61) && (myLCDDriver.KeyPadReadBuf[3] <= 0x70))
                    {
                        switch (myLCDDriver.KeyPadReadBuf[3])
                        //switch(SPIReadKeyPadByteBuf[0])
                        {
                            case 0x61:
                                {
                                    bWriteLCDChar[2] = 0x31;  //1
                                    break;
                                }
                            case 0x62:
                                {
                                    bWriteLCDChar[2] = 0x32; //2
                                    break;
                                }
                            case 0x63:
                                {
                                    bWriteLCDChar[2] = 0x33;  //3
                                    break;
                                }
                            case 0x64:
                                {
                                    bWriteLCDChar[2] = 0xC4;    //Enter
                                    break;
                                }
                            case 0x65:
                                {
                                    bWriteLCDChar[2] = 0x34;  //4
                                    break;
                                }
                            case 0x66:
                                {
                                    bWriteLCDChar[2] = 0x35; //5
                                    break;
                                }
                            case 0x67:
                                {
                                    bWriteLCDChar[2] = 0x36;  //6
                                    break;
                                }
                            case 0x68:
                                {
                                    bWriteLCDChar[2] = 0xC5;    //Up arrow
                                    break;
                                }
                            case 0x69:
                                {
                                    bWriteLCDChar[2] = 0x37;  //7
                                    break;
                                }
                            case 0x6A:
                                {
                                    bWriteLCDChar[2] = 0x38;  //8
                                    break;
                                }
                            case 0x6B:
                                {
                                    bWriteLCDChar[2] = 0x39; //9
                                    break;
                                }
                            case 0x6C:
                                {
                                    bWriteLCDChar[2] = 0xC6;    //Down arrow
                                    break;
                                }
                            case 0x6D:
                                {
                                    bWriteLCDChar[2] = 0xB7;    //Cancel
                                    break;
                                }
                            case 0x6E:
                                {
                                    bWriteLCDChar[2] = 0x30; //0
                                    break;
                                }
                            case 0x6F:
                                {
                                    bWriteLCDChar[2] = 0xC8;    //Left arrow
                                    break;
                                }
                            case 0x70:
                                {
                                    bWriteLCDChar[2] = 0xC7;    //Right arrow
                                    break;
                                }
                            default:
                                {
                                    bWriteLCDChar[2] = 0x00;
                                    break;
                                }
                        }

                        if (bWriteLCDChar[2] != 0x00)
                        {
                            mySPIPort.Write(bWriteLCDChar);
                        }

                        Thread.Sleep(100);
                    }
                }
            }
        }
    }
}
